
rndseed(93847562);

/*Player1: CVS
Player2: Rite Aid
Player3: Walgreens*/

dinit=date;
simulat=200; 
b_L=0.00001;


simetria_within=0; /*1 if we require that each player care equally about both opponents, 0 otherwise*/
constant_strategic=0; /*1 if constant strategic interaction coefficients, zero otherwise*/
simetria_total=1; /*1 if we want all parameters to be the same across players (plus WITHIN symmetry)*/
constant_asymmetric=0;

if constant_strategic .eq 1;
simetria_within=0;
simetria_total=0;
endif;

if simetria_total .eq 1;
simetria_within=0;
constant_asymmetric=0;
endif;

c_value=cdfni(0.95);

y1_max=100;
y2_max=100;
y3_max=100;



critt=1; 
theta_max=6; 
grid_size=3000; /*Use 3000 here*/


L=954; /*Sample size*/

load datos[L,13]=data_pharmacies_sept_2012.asc;
population=datos[.,5];

L=rows(datos);

cbsas=datos[.,1];
Y1=datos[.,2];
Y2=datos[.,3];
Y3=datos[.,4];

population=datos[.,5];
income=datos[.,6];
median_age=datos[.,7];
payroll=datos[.,8];
landarea=datos[.,9];
distance1=datos[.,10]+1;
distance2=datos[.,11]+1;
distance3=datos[.,12]+1;
business=datos[.,13];

density=population./landarea;
business_percap=business./population;
payroll_percap=payroll./population;

X=(population~income~density~median_age~business)~distance1~distance2~distance3;

cont_covars=X;

population=datos[.,5]/500000; /*We measure population in half-a-million people units in the strategic index*/

z=cols(cont_covars); /*Number of continuous covariates in X*/

population_range=maxc(population);

epsilon_h=(9/10)*1/(4*z*(2*z+1));
alpha_h=1/(4*z)-epsilon_h; /*For the rate of the bandwidth*/


sup=30;
c1=323323/24159191040000;
c2=-(7436429/4696546738176000000);
c3=1509595087/33815136514867200000000000;
c4=-(73538846381/146081389744226304000000000000000);
c5=19046561212679/6815573319906622439424000000000000000000;
c6=-(922892466032537/110412287782487283518668800000000000000000000000);
c7=436092044389001/31798738881356337653376614400000000000000000000000000;
c8=-(143474282603981329/12363349677071344079632827678720000000000000000000000000000000);
c9=7604136978011010437/1922748141778135431264497360594534400000000000000000000000000000000000;
Rk=173955989109241405262753588031/772455899253990440701354049536;
Kv=129140163000000000000000000/1440973;
M=18;
c_h=2*((sqrt(pi)*((M!)^3)*Rk)/((2*M)*((2*M)!)*(Kv^2)))^(1/(2*M+1));
bandwidths_trim=c_h*stdc(cont_covars)'*(L^-alpha_h);
bandwidths=c_h*stdc(cont_covars)'*(L^-alpha_h);



band_prod=1;
i=1;
do while i .le cols(bandwidths);
band_prod=band_prod*bandwidths[i];
i=i+1;
endo;


proc kernels(x);
local cont_values, x_val_cont, psi, kernel_matr;
local kernel_matr_normalized, kernel_vector, i, s_2;

s_2=ones(L,z)*sup^2;
x_val_cont=x[1:z];
cont_values=ones(L,z).*x_val_cont;
psi=(cont_covars-cont_values)./bandwidths;

kernel_matr=(c1*(s_2-psi^2)^2+c2*(s_2-psi^2)^4+c3*(s_2-psi^2)^6
+c4*(s_2-psi^2)^8+c5*(s_2-psi^2)^10+c6*(s_2-psi^2)^12
+c7*(s_2-psi^2)^14+c8*(s_2-psi^2)^16+c9*(s_2-psi^2)^18).*(abs(psi) .le sup);

kernel_matr_normalized=kernel_matr./bandwidths;
kernel_vector=ones(L,1);

i=1;
do while i .le z;
kernel_vector=kernel_vector.*kernel_matr_normalized[.,i];
i=i+1;
endo;

retp(kernel_vector);
endp;


proc kernels_trim(x);
local cont_values, x_val_cont, psi, kernel_matr;
local kernel_matr_normalized, kernel_vector, i, s_2;

s_2=ones(L,z)*sup^2;
x_val_cont=x[1:z];
cont_values=ones(L,z).*x_val_cont;
psi=(cont_covars-cont_values)./bandwidths_trim;

kernel_matr=(c1*(s_2-psi^2)^2+c2*(s_2-psi^2)^4+c3*(s_2-psi^2)^6
+c4*(s_2-psi^2)^8+c5*(s_2-psi^2)^10+c6*(s_2-psi^2)^12
+c7*(s_2-psi^2)^14+c8*(s_2-psi^2)^16+c9*(s_2-psi^2)^18).*(abs(psi) .le sup);

kernel_matr_normalized=kernel_matr./bandwidths_trim;
kernel_vector=ones(L,1);

i=1;
do while i .le z;
kernel_vector=kernel_vector.*kernel_matr_normalized[.,i];
i=i+1;
endo;

retp(kernel_vector);
endp;


kernel_matrix=zeros(L,L);

i=1;
do while i .le L;
x_value=cont_covars[i,.];
kernel_matrix[.,i]=kernels(x_value);
i=i+1;
endo;

kernel_matrix=diagrv(kernel_matrix,zeros(L,1));

kernel_matrix_trim=zeros(L,L);

i=1;
do while i .le L;
x_value=cont_covars[i,.];
kernel_matrix_trim[.,i]=kernels_trim(x_value);
i=i+1;
endo;

kernel_matrix_trim=diagrv(kernel_matrix_trim,zeros(L,1));


fx=meanc(kernel_matrix);

fx_trim=meanc(kernel_matrix_trim);

trim_aux=selif(fx_trim, fx_trim .gt 0);
trim_x=(fx .ge quantile(trim_aux,0.15)).*(datos[.,5] .le 5000000);
trim_x=minc(trim_x');
fx=fx.*trim_x+(1-trim_x).*minc(trim_aux);
trimming_p1=trim_x.*(Y1 .le y1_max);
trimming_p2=trim_x.*(Y2 .le y2_max);
trimming_p3=trim_x.*(Y3 .le y3_max);

trimming_all=(trimming_p1).*(trimming_p2).*(trimming_p3);

thr_dis=200;

/*Strategic interaction index*/
V_12=ones(L,1)~(1/population)~(distance1-distance2-thr_dis).*(distance1-distance2 .ge thr_dis)~(distance1-distance2-thr_dis).*(distance1-distance2 .ge thr_dis)./population;
V_13=ones(L,1)~(1/population)~(distance1-distance3-thr_dis).*(distance1-distance3 .ge thr_dis)~(distance1-distance3-thr_dis).*(distance1-distance3 .ge thr_dis)./population;
V_21=ones(L,1)~(1/population)~(distance2-distance1-thr_dis).*(distance2-distance1 .ge thr_dis)~(distance2-distance1-thr_dis).*(distance2-distance1 .ge thr_dis)./population;
V_23=ones(L,1)~(1/population)~(distance2-distance3-thr_dis).*(distance2-distance3 .ge thr_dis)~(distance2-distance3-thr_dis).*(distance2-distance3 .ge thr_dis)./population;
V_31=ones(L,1)~(1/population)~(distance3-distance1-thr_dis).*(distance3-distance1 .ge thr_dis)~(distance3-distance1-thr_dis).*(distance3-distance1 .ge thr_dis)./population;
V_32=ones(L,1)~(1/population)~(distance3-distance2-thr_dis).*(distance3-distance2 .ge thr_dis)~(distance3-distance2-thr_dis).*(distance3-distance2 .ge thr_dis)./population;


if constant_asymmetric .eq 1;
V_12=ones(L,1);
V_13=ones(L,1);
V_21=ones(L,1);
V_23=ones(L,1);
V_31=ones(L,1);
V_32=ones(L,1);
endif;


if constant_strategic .eq 1;
V_12=ones(L,1);
V_13=ones(L,1);
V_21=ones(L,1);
V_23=ones(L,1);
V_31=ones(L,1);
V_32=ones(L,1);
endif;

theta1_elegidas=zeros(1,cols(V_12)+cols(V_13));
theta12_elegidas=zeros(1,cols(V_12));
theta13_elegidas=zeros(1,cols(V_13));

theta2_elegidas=zeros(1,cols(V_21)+cols(V_23));
theta21_elegidas=zeros(1,cols(V_21));
theta23_elegidas=zeros(1,cols(V_23));

theta3_elegidas=zeros(1,cols(V_31)+cols(V_32));
theta31_elegidas=zeros(1,cols(V_31));
theta32_elegidas=zeros(1,cols(V_32));

t_statistic_p1_elegidas=0;
t_statistic_p2_elegidas=0;
t_statistic_p3_elegidas=0;


VV_12=selif(V_12, population .le population_range);
VV_13=selif(V_13, population .le population_range);

VV_21=selif(V_21, population .le population_range);
VV_23=selif(V_23, population .le population_range);

VV_31=selif(V_31, population .le population_range);
VV_32=selif(V_32, population .le population_range);



sim=1;
do while sim .le simulat;

if constant_strategic .eq 1;
theta_12_grid=ones(grid_size,1);
theta_13_grid=ones(grid_size,1);
theta_21_grid=ones(grid_size,1);
theta_23_grid=ones(grid_size,1);
theta_31_grid=ones(grid_size,1);
theta_32_grid=ones(grid_size,1);

else;

if simetria_total .eq 1;

    if cols(VV_12) .ge 2;
    theta_all_grid=1~zeros(1,cols(VV_12)-1);
    else;
    theta_all_grid=ones(grid_size,1);
    endif;

    if cols(VV_12) .ge 2;
        aal=1;
        do while aal .le 2;
        theta_all_aux=rndu(grid_size,cols(VV_12))*6-rndu(grid_size,cols(VV_12))*6;
        vv12_matrix_aux=theta_all_aux*VV_12';
        vv13_matrix_aux=theta_all_aux*VV_13';
        vv21_matrix_aux=theta_all_aux*VV_21';
        vv23_matrix_aux=theta_all_aux*VV_23';
        vv31_matrix_aux=theta_all_aux*VV_31';
        vv32_matrix_aux=theta_all_aux*VV_32';
        vv_all_pos=
        (vv12_matrix_aux' .ge 0).*(vv13_matrix_aux' .ge 0).*(vv21_matrix_aux' .ge 0).*(vv23_matrix_aux' .ge 0).*(vv31_matrix_aux' .ge 0).*(vv32_matrix_aux' .ge 0);
            if sumc((meanc(vv_all_pos) .ge critt)) .gt 0;
            theta_all_pos=selif(theta_all_aux, (meanc(vv_all_pos) .ge critt));
            theta_all_grid=theta_all_grid|theta_all_pos;
            else;
            theta_all_grid=theta_all_grid;
            endif;
                if rows(theta_all_grid) .ge grid_size;
                aal=3;
                else;
                aal=1;
                endif;
        endo; 
    theta_12_grid=theta_all_grid;
    theta_13_grid=theta_all_grid;
    theta_21_grid=theta_all_grid;
    theta_23_grid=theta_all_grid;
    theta_31_grid=theta_all_grid;
    theta_32_grid=theta_all_grid;
    endif;

else;

if simetria_within .eq 1;

    if cols(VV_12) .ge 2;
    theta_1_grid=1~zeros(1,cols(VV_12)-1);
    else;
    theta_1_grid=ones(grid_size,1);
    endif;

    if cols(VV_12) .ge 2;
        aal=1;
        do while aal .le 2;
        theta_1_aux=rndu(grid_size,cols(VV_12))*6-rndu(grid_size,cols(VV_12))*6;
        vv12_matrix_aux=theta_1_aux*VV_12';
        vv13_matrix_aux=theta_1_aux*VV_13';
        vv_1_pos=(vv12_matrix_aux' .ge 0).*(vv13_matrix_aux' .ge 0);
            if sumc((meanc(vv_1_pos) .ge critt)) .gt 0;
            theta_1_pos=selif(theta_1_aux, (meanc(vv_1_pos) .ge critt));
            theta_1_grid=theta_1_grid|theta_1_pos;
            else;
            theta_1_grid=theta_1_grid;
            endif;
                if rows(theta_1_grid) .ge grid_size;
                aal=3;
                else;
                aal=1;
                endif;
        endo; 
    endif;
    theta_12_grid=theta_1_grid;
    theta_13_grid=theta_1_grid;
 

    if cols(VV_21) .ge 2;
    theta_2_grid=1~zeros(1,cols(VV_21)-1);
    else;
    theta_2_grid=ones(grid_size,1);
    endif;

    if cols(VV_21) .ge 2;
        aal=1;
        do while aal .le 2;
        theta_2_aux=rndu(grid_size,cols(VV_21))*6-rndu(grid_size,cols(VV_21))*6;
        vv21_matrix_aux=theta_2_aux*VV_21';
        vv23_matrix_aux=theta_2_aux*VV_23';
        vv_2_pos=(vv21_matrix_aux' .ge 0).*(vv23_matrix_aux' .ge 0);
            if sumc((meanc(vv_2_pos) .ge critt)) .gt 0;
            theta_2_pos=selif(theta_2_aux, (meanc(vv_2_pos) .ge critt));
            theta_2_grid=theta_2_grid|theta_2_pos;
            else;
            theta_2_grid=theta_2_grid;
            endif;
                if rows(theta_2_grid) .ge grid_size;
                aal=3;
                else;
                aal=1;
                endif;
        endo; 
    endif;
    theta_21_grid=theta_2_grid;
    theta_23_grid=theta_2_grid;


    if cols(VV_31) .ge 2;
    theta_3_grid=1~zeros(1,cols(VV_31)-1);
    else;
    theta_3_grid=ones(grid_size,1);
    endif;

    if cols(VV_31) .ge 2;
        aal=1;
        do while aal .le 2;
        theta_3_aux=rndu(grid_size,cols(VV_31))*6-rndu(grid_size,cols(VV_31))*6;
        vv31_matrix_aux=theta_3_aux*VV_31';
        vv32_matrix_aux=theta_3_aux*VV_32';
        vv_3_pos=(vv31_matrix_aux' .ge 0).*(vv32_matrix_aux' .ge 0);
            if sumc((meanc(vv_3_pos) .ge critt)) .gt 0;
            theta_3_pos=selif(theta_3_aux, (meanc(vv_3_pos) .ge critt));
            theta_3_grid=theta_3_grid|theta_3_pos;
            else;
            theta_3_grid=theta_3_grid;
            endif;
                if rows(theta_3_grid) .ge grid_size;
                aal=3;
                else;
                aal=1;
                endif;
        endo; 
    endif;
    theta_31_grid=theta_3_grid;
    theta_32_grid=theta_3_grid;
 
endif;

if simetria_within .eq 0;

    if cols(VV_12) .ge 2;
    theta_12_grid=1~zeros(1,cols(VV_12)-1);
    theta_13_grid=1~zeros(1,cols(VV_13)-1);
    else;
    theta_12_grid=ones(grid_size,1);
    theta_13_grid=ones(grid_size,1);
    endif;

    if cols(VV_12) .ge 2;
        aal=1;
        do while aal .le 2;
        theta_12_aux=rndu(grid_size,cols(VV_12))*6-rndu(grid_size,cols(VV_12))*6;
        theta_13_aux=rndu(grid_size,cols(VV_13))*6-rndu(grid_size,cols(VV_13))*6;
        vv12_matrix_aux=theta_12_aux*VV_12';
        vv13_matrix_aux=theta_13_aux*VV_13';
        vv_1_pos=(vv12_matrix_aux' .ge 0).*(vv13_matrix_aux' .ge 0);
            if sumc((meanc(vv_1_pos) .ge critt)) .gt 0;
            theta_12_pos=selif(theta_12_aux, (meanc(vv_1_pos) .ge critt));
            theta_13_pos=selif(theta_13_aux, (meanc(vv_1_pos) .ge critt));
            theta_12_grid=theta_12_grid|theta_12_pos;
            theta_13_grid=theta_13_grid|theta_13_pos;
            else;
            theta_12_grid=theta_12_grid;
            theta_13_grid=theta_13_grid;
            endif;
                if rows(theta_12_grid) .ge grid_size;
                aal=3;
                else;
                aal=1;
                endif;
        endo; 
    endif;


    if cols(VV_21) .ge 2;
    theta_21_grid=1~zeros(1,cols(VV_21)-1);
    theta_23_grid=1~zeros(1,cols(VV_23)-1);
    else;
    theta_21_grid=ones(grid_size,1);
    theta_23_grid=ones(grid_size,1);
    endif;

    if cols(VV_21) .ge 2;
        aal=1;
        do while aal .le 2;
        theta_21_aux=rndu(grid_size,cols(VV_21))*6-rndu(grid_size,cols(VV_21))*6;
        theta_23_aux=rndu(grid_size,cols(VV_23))*6-rndu(grid_size,cols(VV_23))*6;
        vv21_matrix_aux=theta_21_aux*VV_21';
        vv23_matrix_aux=theta_23_aux*VV_23';
        vv_2_pos=(vv21_matrix_aux' .ge 0).*(vv23_matrix_aux' .ge 0);
            if sumc((meanc(vv_2_pos) .ge critt)) .gt 0;
            theta_21_pos=selif(theta_21_aux, (meanc(vv_2_pos) .ge critt));
            theta_23_pos=selif(theta_23_aux, (meanc(vv_2_pos) .ge critt));
            theta_21_grid=theta_21_grid|theta_21_pos;
            theta_23_grid=theta_23_grid|theta_23_pos;
            else;
            theta_21_grid=theta_21_grid;
            theta_23_grid=theta_23_grid;
            endif;
                if rows(theta_21_grid) .ge grid_size;
                aal=3;
                else;
                aal=1;
                endif;
        endo; 
    endif;


    if cols(VV_31) .ge 2;
    theta_31_grid=1~zeros(1,cols(VV_31)-1);
    theta_32_grid=1~zeros(1,cols(VV_32)-1);
    else;
    theta_31_grid=ones(grid_size,1);
    theta_32_grid=ones(grid_size,1);
    endif;

    if cols(VV_31) .ge 2;
        aal=1;
        do while aal .le 2;
        theta_31_aux=rndu(grid_size,cols(VV_31))*6-rndu(grid_size,cols(VV_31))*6;
        theta_32_aux=rndu(grid_size,cols(VV_32))*6-rndu(grid_size,cols(VV_32))*6;
        vv31_matrix_aux=theta_31_aux*VV_31';
        vv32_matrix_aux=theta_32_aux*VV_32';
        vv_3_pos=(vv31_matrix_aux' .ge 0).*(vv32_matrix_aux' .ge 0);
            if sumc((meanc(vv_3_pos) .ge critt)) .gt 0;
            theta_31_pos=selif(theta_31_aux, (meanc(vv_3_pos) .ge critt));
            theta_32_pos=selif(theta_32_aux, (meanc(vv_3_pos) .ge critt));
            theta_31_grid=theta_31_grid|theta_31_pos;
            theta_32_grid=theta_32_grid|theta_32_pos;
            else;
            theta_31_grid=theta_31_grid;
            theta_32_grid=theta_32_grid;
            endif;
                if rows(theta_31_grid) .ge grid_size;
                aal=3;
                else;
                aal=1;
                endif;
        endo; 
    endif;

endif;

endif;


endif;


if constant_asymmetric .eq 1;
theta_12_grid=rndu(grid_size,1)*6-rndu(grid_size,1)*6;
theta_12_grid=maxc((theta_12_grid~zeros(grid_size,1))');
theta_13_grid_aux=rndu(grid_size,1)*6-rndu(grid_size,1)*6;
theta_13_grid_aux=maxc((theta_13_grid_aux~zeros(grid_size,1))');
theta_13_grid=(theta_12_grid .eq 0)+(theta_12_grid .ne 0).*theta_13_grid_aux;

theta_21_grid=rndu(grid_size,1)*6-rndu(grid_size,1)*6;
theta_21_grid=maxc((theta_21_grid~zeros(grid_size,1))');
theta_23_grid_aux=rndu(grid_size,1)*6-rndu(grid_size,1)*6;
theta_23_grid_aux=maxc((theta_23_grid_aux~zeros(grid_size,1))');
theta_23_grid=(theta_21_grid .eq 0)+(theta_21_grid .ne 0).*theta_23_grid_aux;

theta_31_grid=rndu(grid_size,1)*6-rndu(grid_size,1)*6;
theta_31_grid=maxc((theta_31_grid~zeros(grid_size,1))');
theta_32_grid_aux=rndu(grid_size,1)*6-rndu(grid_size,1)*6;
theta_32_grid_aux=maxc((theta_32_grid_aux~zeros(grid_size,1))');
theta_32_grid=(theta_31_grid .eq 0)+(theta_31_grid .ne 0).*theta_32_grid_aux;
endif;


theta_12_grid=theta_12_grid[1:grid_size,.];
theta_13_grid=theta_13_grid[1:grid_size,.];
theta_21_grid=theta_21_grid[1:grid_size,.];
theta_23_grid=theta_23_grid[1:grid_size,.];
theta_31_grid=theta_31_grid[1:grid_size,.];
theta_32_grid=theta_32_grid[1:grid_size,.];

theta_1_grid=theta_12_grid~theta_13_grid;
theta_2_grid=theta_21_grid~theta_23_grid;
theta_3_grid=theta_31_grid~theta_32_grid;

if simetria_within .eq 1;
theta1_norm=sumc((theta_12_grid.*theta_12_grid)');
theta2_norm=sumc((theta_21_grid.*theta_21_grid)');
theta3_norm=sumc((theta_31_grid.*theta_31_grid)');
endif;

if simetria_total .eq 1;
theta1_norm=sumc((theta_12_grid.*theta_12_grid)');
theta2_norm=sumc((theta_21_grid.*theta_21_grid)');
theta3_norm=sumc((theta_31_grid.*theta_31_grid)');
endif;

if maxc(simetria_within|simetria_total) .eq 0;
theta1_norm=sumc((theta_1_grid.*theta_1_grid)');
theta2_norm=sumc((theta_2_grid.*theta_2_grid)');
theta3_norm=sumc((theta_3_grid.*theta_3_grid)');
endif;

if constant_asymmetric .eq 1;
theta1_norm=sumc((theta_1_grid.*theta_1_grid)');
theta2_norm=sumc((theta_2_grid.*theta_2_grid)');
theta3_norm=sumc((theta_3_grid.*theta_3_grid)');
endif;

if constant_strategic .eq 1;
theta1_norm=1;
theta2_norm=1;
theta3_norm=1;
endif;

V_1=V_12~V_13;
V_2=V_21~V_23;
V_3=V_31~V_32;


/*Fix the norm to one in the parameter space*/
theta_12_grid=theta_12_grid./sqrt(theta1_norm);
theta_13_grid=theta_13_grid./sqrt(theta1_norm);

theta_21_grid=theta_21_grid./sqrt(theta2_norm);
theta_23_grid=theta_23_grid./sqrt(theta2_norm);

theta_31_grid=theta_31_grid./sqrt(theta3_norm);
theta_32_grid=theta_32_grid./sqrt(theta3_norm);

theta_1_grid=theta_12_grid~theta_13_grid;
theta_2_grid=theta_21_grid~theta_23_grid;
theta_3_grid=theta_31_grid~theta_32_grid;

phi_12_matrix=V_12*theta_12_grid';
phi_13_matrix=V_13*theta_13_grid';

phi_21_matrix=V_21*theta_21_grid';
phi_23_matrix=V_23*theta_23_grid';

phi_31_matrix=V_31*theta_31_grid';
phi_32_matrix=V_32*theta_32_grid';

E_Y1_le_y1=meanc((Y1 .le Y1').*kernel_matrix)./fx;
E_Y2_le_y2=meanc((Y2 .le Y2').*kernel_matrix)./fx;
E_Y3_le_y3=meanc((Y3 .le Y3').*kernel_matrix)./fx;

E_Y1_le_y1=minc((E_Y1_le_y1~ones(L,1))');
E_Y2_le_y2=minc((E_Y2_le_y2~ones(L,1))');
E_Y3_le_y3=minc((E_Y3_le_y3~ones(L,1))');

E_Y1_le_y1=maxc((E_Y1_le_y1~zeros(L,1))');
E_Y2_le_y2=maxc((E_Y2_le_y2~zeros(L,1))');
E_Y3_le_y3=maxc((E_Y3_le_y3~zeros(L,1))');

E_Y2_phi_12=zeros(L,grid_size);
E_Y3_phi_13=zeros(L,grid_size);

E_Y1_phi_21=zeros(L,grid_size);
E_Y3_phi_23=zeros(L,grid_size);

E_Y1_phi_31=zeros(L,grid_size);
E_Y2_phi_32=zeros(L,grid_size);

E_Y2_phi_12_Y1_le_y1=zeros(L,grid_size);
E_Y3_phi_13_Y1_le_y1=zeros(L,grid_size);

E_Y1_phi_21_Y2_le_y2=zeros(L,grid_size);
E_Y3_phi_23_Y2_le_y2=zeros(L,grid_size);

E_Y1_phi_31_Y3_le_y3=zeros(L,grid_size);
E_Y2_phi_32_Y3_le_y3=zeros(L,grid_size);

E_Y1_le_y1_big_phi1=zeros(L,grid_size);
E_Y2_le_y2_big_phi2=zeros(L,grid_size);
E_Y3_le_y3_big_phi3=zeros(L,grid_size);

matrix_R1=zeros(L,grid_size);
matrix_R2=zeros(L,grid_size);
matrix_R3=zeros(L,grid_size);


i=1;
do while i .le L;
E_Y2_phi_12[i,.]=(meanc(Y2 .*phi_12_matrix.*kernel_matrix[.,i])/fx[i])';
E_Y3_phi_13[i,.]=(meanc(Y3 .*phi_13_matrix.*kernel_matrix[.,i])/fx[i])';

E_Y1_phi_21[i,.]=(meanc(Y1 .*phi_21_matrix.*kernel_matrix[.,i])/fx[i])';
E_Y3_phi_23[i,.]=(meanc(Y3 .*phi_23_matrix.*kernel_matrix[.,i])/fx[i])';

E_Y1_phi_31[i,.]=(meanc(Y1 .*phi_31_matrix.*kernel_matrix[.,i])/fx[i])';
E_Y2_phi_32[i,.]=(meanc(Y2 .*phi_32_matrix.*kernel_matrix[.,i])/fx[i])';


E_Y2_phi_12_Y1_le_y1[i,.]=(meanc(Y2 .*phi_12_matrix.*(Y1 .le Y1[i]).*kernel_matrix[.,i])/fx[i])';
E_Y3_phi_13_Y1_le_y1[i,.]=(meanc(Y3 .*phi_13_matrix.*(Y1 .le Y1[i]).*kernel_matrix[.,i])/fx[i])';

E_Y1_phi_21_Y2_le_y2[i,.]=(meanc(Y1 .*phi_21_matrix.*(Y2 .le Y2[i]).*kernel_matrix[.,i])/fx[i])';
E_Y3_phi_23_Y2_le_y2[i,.]=(meanc(Y3 .*phi_23_matrix.*(Y2 .le Y2[i]).*kernel_matrix[.,i])/fx[i])';

E_Y1_phi_31_Y3_le_y3[i,.]=(meanc(Y1 .*phi_31_matrix.*(Y3 .le Y3[i]).*kernel_matrix[.,i])/fx[i])';
E_Y2_phi_32_Y3_le_y3[i,.]=(meanc(Y2 .*phi_32_matrix.*(Y3 .le Y3[i]).*kernel_matrix[.,i])/fx[i])';

E_Y1_le_y1_big_phi1[i,.]=E_Y2_phi_12_Y1_le_y1[i,.]+E_Y3_phi_13_Y1_le_y1[i,.];
E_Y2_le_y2_big_phi2[i,.]=E_Y1_phi_21_Y2_le_y2[i,.]+E_Y3_phi_23_Y2_le_y2[i,.];
E_Y3_le_y3_big_phi3[i,.]=E_Y1_phi_31_Y3_le_y3[i,.]+E_Y2_phi_32_Y3_le_y3[i,.];


matrix_R1[i,.]=((E_Y2_phi_12[i,.]+E_Y3_phi_13[i,.])*E_Y1_le_y1[i]-E_Y1_le_y1_big_phi1[i,.]);
matrix_R2[i,.]=((E_Y1_phi_21[i,.]+E_Y3_phi_23[i,.])*E_Y2_le_y2[i]-E_Y2_le_y2_big_phi2[i,.]);
matrix_R3[i,.]=((E_Y1_phi_31[i,.]+E_Y2_phi_32[i,.])*E_Y3_le_y3[i]-E_Y3_le_y3_big_phi3[i,.]);

i=i+1;
endo;

unos_matrix=ones(L,grid_size);

matrix_influence_p1=zeros(L,grid_size);
i=1;
do while i .le L;
matrix_influence_p1[i,.]=
(meanc((1/fx).*(E_Y2_phi_12.*((Y1[i] .le Y1)-E_Y1_le_y1)+E_Y1_le_y1.*(Y2[i]*phi_12_matrix[i,.].*unos_matrix-E_Y2_phi_12)
-(Y2[i].*phi_12_matrix[i,.].*unos_matrix.*(Y1[i] .le Y1)-E_Y2_phi_12_Y1_le_y1)).*(matrix_R1 .ge -b_L).*trimming_p1.*kernel_matrix[.,i]))'
+
(meanc((1/fx).*(E_Y3_phi_13.*((Y1[i] .le Y1)-E_Y1_le_y1)+E_Y1_le_y1.*(Y3[i]*phi_13_matrix[i,.].*unos_matrix-E_Y3_phi_13)
-(Y3[i].*phi_13_matrix[i,.].*unos_matrix.*(Y1[i] .le Y1)-E_Y3_phi_13_Y1_le_y1)).*(matrix_R1 .ge -b_L).*trimming_p1.*kernel_matrix[.,i]))';
i=i+1;
endo;


full_influence_p1=matrix_influence_p1+matrix_R1.*(matrix_R1 .ge -b_L).*trimming_p1;


matrix_influence_p2=zeros(L,grid_size);
i=1;
do while i .le L;
matrix_influence_p2[i,.]=
(meanc((1/fx).*(E_Y1_phi_21.*((Y2[i] .le Y2)-E_Y2_le_y2)+E_Y2_le_y2.*(Y1[i]*phi_21_matrix[i,.].*unos_matrix-E_Y1_phi_21)
-(Y1[i].*phi_21_matrix[i,.].*unos_matrix.*(Y2[i] .le Y2)-E_Y1_phi_21_Y2_le_y2)).*(matrix_R2 .ge -b_L).*trimming_p2.*kernel_matrix[.,i]))'
+
(meanc((1/fx).*(E_Y3_phi_23.*((Y2[i] .le Y2)-E_Y2_le_y2)+E_Y2_le_y2.*(Y3[i]*phi_23_matrix[i,.].*unos_matrix-E_Y3_phi_23)
-(Y3[i].*phi_23_matrix[i,.].*unos_matrix.*(Y2[i] .le Y2)-E_Y3_phi_23_Y2_le_y2)).*(matrix_R2 .ge -b_L).*trimming_p2.*kernel_matrix[.,i]))';
i=i+1;
endo;


full_influence_p2=matrix_influence_p2+matrix_R2.*(matrix_R2 .ge -b_L).*trimming_p2;


matrix_influence_p3=zeros(L,grid_size);
i=1;
do while i .le L;
matrix_influence_p3[i,.]=
(meanc((1/fx).*(E_Y1_phi_31.*((Y3[i] .le Y3)-E_Y3_le_y3)+E_Y3_le_y3.*(Y1[i]*phi_31_matrix[i,.].*unos_matrix-E_Y1_phi_31)
-(Y1[i].*phi_31_matrix[i,.].*unos_matrix.*(Y3[i] .le Y3)-E_Y1_phi_31_Y3_le_y3)).*(matrix_R3 .ge -b_L).*trimming_p3.*kernel_matrix[.,i]))'
+
(meanc((1/fx).*(E_Y2_phi_32.*((Y3[i] .le Y3)-E_Y3_le_y3)+E_Y3_le_y3.*(Y2[i]*phi_32_matrix[i,.].*unos_matrix-E_Y2_phi_32)
-(Y2[i].*phi_32_matrix[i,.].*unos_matrix.*(Y3[i] .le Y3)-E_Y2_phi_32_Y3_le_y3)).*(matrix_R3 .ge -b_L).*trimming_p3.*kernel_matrix[.,i]))';
i=i+1;
endo;


full_influence_p3=matrix_influence_p3+matrix_R3.*(matrix_R3 .ge -b_L).*trimming_p3;

full_influence_all=full_influence_p1+full_influence_p2+full_influence_p3;


infl_quantile=quantile(abs(full_influence_all),1-5/L);
indic_infl=(abs(full_influence_all) .lt infl_quantile);

indic_infl=1; 

variance_all=meanc((full_influence_all.*indic_infl)^2)-meanc(full_influence_all.*indic_infl)^2;

T_1=meanc(matrix_R1.*(matrix_R1 .ge -b_L).*trimming_p1 .*indic_infl);
T_2=meanc(matrix_R2.*(matrix_R2 .ge -b_L).*trimming_p2 .*indic_infl);
T_3=meanc(matrix_R3.*(matrix_R3 .ge -b_L).*trimming_p3 .*indic_infl);


full_numerator=T_1+T_2+T_3;

Z_statistic=sqrt(L)*full_numerator./sqrt(abs(variance_all));

Z_c_value=cdfni(0.95);


if sumc(Z_statistic .le Z_c_value) .ge 1;
theta1_elegidas=theta1_elegidas|selif(theta_1_grid, Z_statistic .le Z_c_value);
theta2_elegidas=theta2_elegidas|selif(theta_2_grid, Z_statistic .le Z_c_value);
theta3_elegidas=theta3_elegidas|selif(theta_3_grid, Z_statistic .le Z_c_value);
theta12_elegidas=theta12_elegidas|selif(theta_12_grid, Z_statistic .le Z_c_value);
theta13_elegidas=theta13_elegidas|selif(theta_13_grid, Z_statistic .le Z_c_value);
theta21_elegidas=theta21_elegidas|selif(theta_21_grid, Z_statistic .le Z_c_value);
theta23_elegidas=theta23_elegidas|selif(theta_23_grid, Z_statistic .le Z_c_value);
theta31_elegidas=theta31_elegidas|selif(theta_31_grid, Z_statistic .le Z_c_value);
theta32_elegidas=theta32_elegidas|selif(theta_32_grid, Z_statistic .le Z_c_value);
else;
theta1_elegidas=theta1_elegidas;
theta2_elegidas=theta2_elegidas;
theta3_elegidas=theta3_elegidas;
theta12_elegidas=theta12_elegidas;
theta13_elegidas=theta13_elegidas;
theta21_elegidas=theta21_elegidas;
theta23_elegidas=theta23_elegidas;
theta31_elegidas=theta31_elegidas;
theta32_elegidas=theta32_elegidas;
endif;


sim=sim+1;

endo;

nonzero_p1=sumc(abs(theta1_elegidas)');
nonzero_p2=sumc(abs(theta2_elegidas)');
nonzero_p3=sumc(abs(theta3_elegidas)');

theta1_elegidas=selif(theta1_elegidas, nonzero_p1 .gt 0);
theta2_elegidas=selif(theta2_elegidas, nonzero_p2 .gt 0);
theta3_elegidas=selif(theta3_elegidas, nonzero_p3 .gt 0);

theta12_elegidas=selif(theta12_elegidas, nonzero_p1 .gt 0);
theta13_elegidas=selif(theta13_elegidas, nonzero_p1 .gt 0);

theta21_elegidas=selif(theta21_elegidas, nonzero_p2 .gt 0);
theta23_elegidas=selif(theta23_elegidas, nonzero_p2 .gt 0);

theta31_elegidas=selif(theta31_elegidas, nonzero_p3 .gt 0);
theta32_elegidas=selif(theta32_elegidas, nonzero_p3 .gt 0);

pop_counterf=1;

VV_12_counterf=1~1/pop_counterf~1*500~1*500/pop_counterf;
VV_13_counterf=1~1/pop_counterf~1*250~1*250/pop_counterf;

VV_21_counterf=1~1/pop_counterf~1*500~1*500/pop_counterf;
VV_23_counterf=1~1/pop_counterf~1*250~1*250/pop_counterf;

VV_31_counterf=1~1/pop_counterf~1*500~1*500/pop_counterf;
VV_32_counterf=1~1/pop_counterf~1*250~1*250/pop_counterf;

pop_seqa=seqa(0.05,0.01,1000);
VV_population_only=ones(1000,1)~(1/pop_seqa)~zeros(1000,2);

pop_distance=1;
distance_seqa=seqa(0,1,300);
VV_distance_only=ones(300,1)~(1/pop_distance)*ones(300,1)~distance_seqa~distance_seqa/pop_distance;


if sumc(nonzero_p1) .gt 0;

phi_12_elegidas=VV_12*theta12_elegidas';
phi_12_min=minc(phi_12_elegidas');
phi_12_max=maxc(phi_12_elegidas');

phi_13_elegidas=VV_13*theta13_elegidas';
phi_13_min=minc(phi_13_elegidas');
phi_13_max=maxc(phi_13_elegidas');

phi_12_counterf_elegidas=VV_12_counterf*theta12_elegidas';
phi_13_counterf_elegidas=VV_13_counterf*theta13_elegidas';

phi_12_population_only=VV_population_only*theta12_elegidas';
phi_13_population_only=VV_population_only*theta13_elegidas';
phi_12_min_population=minc(phi_12_population_only');
phi_12_max_population=maxc(phi_12_population_only');
phi_13_min_population=minc(phi_13_population_only');
phi_13_max_population=maxc(phi_13_population_only');
phi_1_rel_pop_only=phi_12_population_only./(phi_12_population_only+phi_13_population_only);


phi_12_distance_only=VV_distance_only*theta12_elegidas';
phi_13_distance_only=VV_distance_only*theta13_elegidas';
phi_12_min_distance=minc(phi_12_distance_only');
phi_12_max_distance=maxc(phi_12_distance_only');
phi_13_min_distance=minc(phi_13_distance_only');
phi_13_max_distance=maxc(phi_13_distance_only');



correl_p1=zeros(rows(theta1_elegidas),1);
j=1;
do while j .le rows(theta1_elegidas);
aux_corrx=corrx((Y1~phi_12_elegidas[.,j].*Y2+phi_13_elegidas[.,j].*Y3).*1);
correl_p1[j]=aux_corrx[1,2];
j=j+1;
endo;

else;
phi_12_elegidas=0;
phi_12_min=0;
phi_12_max=0;
phi_13_elegidas=0;
phi_13_min=0;
phi_13_max=0;
correl_p1=0;

endif;



if sumc(nonzero_p2) .gt 0;

phi_21_elegidas=VV_21*theta21_elegidas';
phi_21_min=minc(phi_21_elegidas');
phi_21_max=maxc(phi_21_elegidas');

phi_23_elegidas=VV_23*theta23_elegidas';
phi_23_min=minc(phi_23_elegidas');
phi_23_max=maxc(phi_23_elegidas');

phi_21_counterf_elegidas=VV_21_counterf*theta21_elegidas';
phi_23_counterf_elegidas=VV_23_counterf*theta23_elegidas';

phi_21_population_only=VV_population_only*theta21_elegidas';
phi_23_population_only=VV_population_only*theta23_elegidas';
phi_21_min_population=minc(phi_21_population_only');
phi_21_max_population=maxc(phi_21_population_only');
phi_23_min_population=minc(phi_23_population_only');
phi_23_max_population=maxc(phi_23_population_only');
phi_2_rel_pop_only=phi_21_population_only./(phi_21_population_only+phi_23_population_only);


phi_21_distance_only=VV_distance_only*theta21_elegidas';
phi_23_distance_only=VV_distance_only*theta23_elegidas';
phi_21_min_distance=minc(phi_21_distance_only');
phi_21_max_distance=maxc(phi_21_distance_only');
phi_23_min_distance=minc(phi_23_distance_only');
phi_23_max_distance=maxc(phi_23_distance_only');


correl_p2=zeros(rows(theta2_elegidas),1);
j=1;
do while j .le rows(theta2_elegidas);
aux_corrx=corrx((Y2~phi_21_elegidas[.,j].*Y1+phi_23_elegidas[.,j].*Y3).*1);
correl_p2[j]=aux_corrx[1,2];
j=j+1;
endo;

else;
phi_21_elegidas=0;
phi_21_min=0;
phi_21_max=0;
phi_23_elegidas=0;
phi_23_min=0;
phi_23_max=0;
correl_p2=0;

endif;



if sumc(nonzero_p3) .gt 0;

phi_31_elegidas=VV_31*theta31_elegidas';
phi_31_min=minc(phi_31_elegidas');
phi_31_max=maxc(phi_31_elegidas');

phi_32_elegidas=VV_32*theta32_elegidas';
phi_32_min=minc(phi_32_elegidas');
phi_32_max=maxc(phi_32_elegidas');

phi_31_counterf_elegidas=VV_31_counterf*theta31_elegidas';
phi_32_counterf_elegidas=VV_32_counterf*theta32_elegidas';

phi_31_population_only=VV_population_only*theta31_elegidas';
phi_32_population_only=VV_population_only*theta32_elegidas';
phi_31_min_population=minc(phi_31_population_only');
phi_31_max_population=maxc(phi_31_population_only');
phi_32_min_population=minc(phi_32_population_only');
phi_32_max_population=maxc(phi_32_population_only');
phi_3_rel_pop_only=phi_31_population_only./(phi_31_population_only+phi_32_population_only);


phi_31_distance_only=VV_distance_only*theta31_elegidas';
phi_32_distance_only=VV_distance_only*theta32_elegidas';
phi_31_min_distance=minc(phi_31_distance_only');
phi_31_max_distance=maxc(phi_31_distance_only');
phi_32_min_distance=minc(phi_32_distance_only');
phi_32_max_distance=maxc(phi_32_distance_only');


correl_p3=zeros(rows(theta3_elegidas),1);
j=1;
do while j .le rows(theta3_elegidas);
aux_corrx=corrx((Y3~phi_31_elegidas[.,j].*Y1+phi_32_elegidas[.,j].*Y2).*1);
correl_p3[j]=aux_corrx[1,2];
j=j+1;
endo;

else;
phi_31_elegidas=0;
phi_31_min=0;
phi_31_max=0;
phi_32_elegidas=0;
phi_32_min=0;
phi_32_max=0;
correl_p3=0;

endif;

if sumc(nonzero_p1) .gt 0;

beta_phi_1=zeros(rows(theta1_elegidas),1);
median_relative_phi_p1=zeros(rows(theta1_elegidas),1);
avg_relative_phi_p1=zeros(rows(theta1_elegidas),1);


prp=1;
do while prp .le rows(theta1_elegidas);
projection_matrix_p1=ones(L,1)~X~phi_12_elegidas[.,prp].*Y2+phi_13_elegidas[.,prp].*Y3;
betas_regression_p1=pinv((projection_matrix_p1')*projection_matrix_p1)*(projection_matrix_p1')*Y1;
beta_phi_1[prp]=betas_regression_p1[rows(betas_regression_p1)];
median_relative_phi_p1[prp]=quantile(phi_12_elegidas[.,prp]./(phi_12_elegidas[.,prp]+phi_13_elegidas[.,prp]),0.5);
avg_relative_phi_p1[prp]=meanc(phi_12_elegidas[.,prp]./(phi_12_elegidas[.,prp]+phi_13_elegidas[.,prp]));
prp=prp+1;
endo;

endif;


if sumc(nonzero_p2) .gt 0;

beta_phi_2=zeros(rows(theta2_elegidas),1);
median_relative_phi_p2=zeros(rows(theta2_elegidas),1);
avg_relative_phi_p2=zeros(rows(theta2_elegidas),1);



prp=1;
do while prp .le rows(theta2_elegidas);
projection_matrix_p2=ones(L,1)~X~phi_21_elegidas[.,prp].*Y1+phi_23_elegidas[.,prp].*Y3;
betas_regression_p2=pinv((projection_matrix_p2')*projection_matrix_p2)*(projection_matrix_p2')*Y2;
beta_phi_2[prp]=betas_regression_p2[rows(betas_regression_p2)];
median_relative_phi_p2[prp]=quantile(phi_21_elegidas[.,prp]./(phi_21_elegidas[.,prp]+phi_23_elegidas[.,prp]),0.5);
avg_relative_phi_p2[prp]=meanc(phi_21_elegidas[.,prp]./(phi_21_elegidas[.,prp]+phi_23_elegidas[.,prp]));
prp=prp+1;
endo;

endif;


if sumc(nonzero_p3) .gt 0;

beta_phi_3=zeros(rows(theta3_elegidas),1);
median_relative_phi_p3=zeros(rows(theta3_elegidas),1);
avg_relative_phi_p3=zeros(rows(theta3_elegidas),1);



prp=1;
do while prp .le rows(theta3_elegidas);
projection_matrix_p3=ones(L,1)~X~phi_31_elegidas[.,prp].*Y1+phi_32_elegidas[.,prp].*Y2;
betas_regression_p3=pinv((projection_matrix_p3')*projection_matrix_p3)*(projection_matrix_p3')*Y3;
beta_phi_3[prp]=betas_regression_p3[rows(betas_regression_p3)];
median_relative_phi_p3[prp]=quantile(phi_31_elegidas[.,prp]./(phi_31_elegidas[.,prp]+phi_32_elegidas[.,prp]),0.5);
avg_relative_phi_p3[prp]=meanc(phi_31_elegidas[.,prp]./(phi_31_elegidas[.,prp]+phi_32_elegidas[.,prp]));
prp=prp+1;
endo;

endif;

if sumc((correl_p1 .lt 0).*(correl_p2 .lt 0).*(correl_p3 .lt 0)) .gt 0;

theta1_elegidas_final=selif(theta1_elegidas, (correl_p1 .lt 0).*(correl_p2 .lt 0).*(correl_p3 .lt 0));
theta2_elegidas_final=selif(theta2_elegidas, (correl_p1 .lt 0).*(correl_p2 .lt 0).*(correl_p3 .lt 0));
theta3_elegidas_final=selif(theta3_elegidas, (correl_p1 .lt 0).*(correl_p2 .lt 0).*(correl_p3 .lt 0));

theta12_elegidas_final=selif(theta12_elegidas, (correl_p1 .lt 0).*(correl_p2 .lt 0).*(correl_p3 .lt 0));
theta13_elegidas_final=selif(theta13_elegidas, (correl_p1 .lt 0).*(correl_p2 .lt 0).*(correl_p3 .lt 0));
theta21_elegidas_final=selif(theta21_elegidas, (correl_p1 .lt 0).*(correl_p2 .lt 0).*(correl_p3 .lt 0));
theta23_elegidas_final=selif(theta23_elegidas, (correl_p1 .lt 0).*(correl_p2 .lt 0).*(correl_p3 .lt 0));
theta31_elegidas_final=selif(theta31_elegidas, (correl_p1 .lt 0).*(correl_p2 .lt 0).*(correl_p3 .lt 0));
theta32_elegidas_final=selif(theta32_elegidas, (correl_p1 .lt 0).*(correl_p2 .lt 0).*(correl_p3 .lt 0));

phi_12_elegidas_final=VV_12*theta12_elegidas_final';
phi_12_min_final=minc(phi_12_elegidas_final');
phi_12_max_final=maxc(phi_12_elegidas_final');

phi_13_elegidas_final=VV_13*theta13_elegidas_final';
phi_13_min_final=minc(phi_13_elegidas_final');
phi_13_max_final=maxc(phi_13_elegidas_final');

correl_p1_final=selif(correl_p1,(correl_p1 .lt 0).*(correl_p2 .lt 0).*(correl_p3 .lt 0));


phi_21_elegidas_final=VV_21*theta21_elegidas_final';
phi_21_min_final=minc(phi_21_elegidas_final');
phi_21_max_final=maxc(phi_21_elegidas_final');

phi_23_elegidas_final=VV_23*theta23_elegidas_final';
phi_23_min_final=minc(phi_23_elegidas_final');
phi_23_max_final=maxc(phi_23_elegidas_final');

correl_p2_final=selif(correl_p2,(correl_p1 .lt 0).*(correl_p2 .lt 0).*(correl_p3 .lt 0));


phi_31_elegidas_final=VV_31*theta31_elegidas_final';
phi_31_min_final=minc(phi_31_elegidas_final');
phi_31_max_final=maxc(phi_31_elegidas_final');

phi_32_elegidas_final=VV_32*theta32_elegidas_final';
phi_32_min_final=minc(phi_32_elegidas_final');
phi_32_max_final=maxc(phi_32_elegidas_final');

correl_p3_final=selif(correl_p3,(correl_p1 .lt 0).*(correl_p2 .lt 0).*(correl_p3 .lt 0));

else;

theta1_elegidas_final=0;
theta2_elegidas_final=0;
theta3_elegidas_final=0;
phi_12_elegidas_final=0;
phi_13_elegidas_final=0;
phi_21_elegidas_final=0;
phi_23_elegidas_final=0;
phi_31_elegidas_final=0;
phi_32_elegidas_final=0;
correl_p1_final=0;
correl_p2_final=0;
correl_p3_final=0;

endif;


dfin=date;
if dfin[3] .eq dinit[3];
totaltime=(dfin[4]-dinit[4])/100;
else;

totaltime=(8640000*(dfin[3]-dinit[3])-dinit[4]+dfin[4])/100;

endif;
