rndseed(93847562);


dinit=date;
simulat=3; /*Number of MC experiments to run*/
sample_size=2000; /*Sample size for MC experiments*/
c_value=cdfni(0.95); /*Nominal significance level*/
gridsize_thetas_CS=100000; /*Number of parameter values to test if we want to estimate a confidence set*/

confidence_set_estimation=1;  /*1 if we want to estimate a confidence set, zero otherwise*/
true_parameters_test=0; /*1 if we want to test if the true parameter belongs in the confidence set, zero otherwise*/
symmetric_first_scenario=0; /*1 if we want to test whether (1,1,1,1,1,1) is in the confidence set, zero otherwise*/
symmetric_second_scenario=0; /*1 if we want to test whether (0,1,0,1,0,1) is in the confidence set, zero otherwise*/
symmetric_third_scenario=0; /*1 if we want to test whether strategic interaction effects are constant across markets and symmetric: (1,0,1,0,1,0)*/

if confidence_set_estimation+true_parameters_test+symmetric_first_scenario+symmetric_second_scenario+symmetric_third_scenario .ne 1;
print "Please choose either confidence_set_estimation or true_parameters_test or symmetric_first_scenario or symmetric_second_scenario or symmetric_third_scenario";
else;

if confidence_set_estimation .eq 1;
simulat=1;
endif;

if confidence_set_estimation .ne 1;
gridsize_thetas_CS=1;
endif;

test_statistics=zeros(simulat*gridsize_thetas_CS,1);
rejection=zeros(simulat*gridsize_thetas_CS,1);
avg_number_of_equilibria=zeros(simulat,1);
median_number_of_equilibria=zeros(simulat,1);

avg_within_correlat_p1=zeros(simulat,1);
avg_within_correlat_p2=zeros(simulat,1);
avg_within_correlat_p3=zeros(simulat,1);

across_correlat_Y1_Y2=zeros(simulat,1);
across_correlat_Y1_Y3=zeros(simulat,1);
across_correlat_Y2_Y3=zeros(simulat,1);


/*DATA GENERATING CODE BEGINS HERE*/
selection_favors_p1=0; /*one if we use an equilibrium selection rule that favors player 1, zero otherwise*/
selection_favors_p2=0; /*one if we use an equilibrium selection rule that favors player 2, zero otherwise*/
selection_favors_p3=0; /*one if we use an equilibrium selection rule that favors player 3, zero otherwise*/
selection_favors_collusion=0; /*one if we use an equilibrium selection rule that maximizes joint profits, zero otherwise*/
selection_favors_monopoly=0; /*one if we use an equilibrium selection rule that favors MONOPOLIES, zero otherwise*/
selection_adaptive_collusion=0; /*with probability 1/2 they choose the best joint outcome for 1 and 3 and with probability 1/2 they choose the best for p2*/ 
selection_adaptive_collusion_bis=1; /*with probability 1/3 they choose randomly, with probability 1/3 they choose the best joint outcome for 1 and 3 and with probability 1/3 they choose the best for p2*/

upper_q=10;
q_sequence=seqa(0,1,upper_q+1);
q_values=q_sequence.*.ones((upper_q+1)^2,1)~ones(upper_q+1,1).*.q_sequence.*.ones(upper_q+1,1)~ones((upper_q+1)^2,1).*.q_sequence;

n=sample_size;
coef=2;
gamma_11=1;
gamma_12=1;
gamma_13=-5;
beta_12=0;
beta_13=1;

gamma_22=1;
gamma_21=1;
gamma_23=1;
beta_21=0;
beta_23=1;

gamma_33=1;
gamma_31=-5;
gamma_32=1;
beta_31=1;
beta_32=1;


sim=1;
do while sim .le simulat;
total_accepted=0;
X_a=coef*((1)*exp(rndn(n,1)));
X_a_bar=coef*exp(0);
X_mc=rndu(n,1);

X_b=rndu(n,1);

MC_p1=1/10*rndu(n,1)+1/10*X_mc;
MC_p2=1/10*rndu(n,1)+1/10*X_mc;
MC_p3=1/10*rndu(n,1)+1/10*X_mc;

F_p1=1+rndu(n,1);
F_p2=1+rndu(n,1);
F_p3=1+rndu(n,1);

number_of_equilibria=ones(n,1)*(-2);

correl_p1=ones(n,1)*(-2);
correl_p2=ones(n,1)*(-2);
correl_p3=ones(n,1)*(-2);

subst_correl_p1=ones(n,1)*(-2);
subst_correl_p2=ones(n,1)*(-2);
subst_correl_p3=ones(n,1)*(-2);

eqbm_outcome=ones(n,3)*(-1);

i=1;
do while i .le n;
number_equilibria=0;
q_sequence_scrambled=sortc(rndu(rows(q_sequence),1)~q_sequence,1);
q_sequence=q_sequence_scrambled[.,2:cols(q_sequence_scrambled)];	
	
equilibrium_indicator=zeros(rows(q_values),1);	
j=1;
do while j .le rows(q_values);
q_1=q_values[j,1];
q_2=q_values[j,2];
q_3=q_values[j,3];
	
a_p1=X_a[i]-MC_p1[i]-(beta_12+gamma_12*X_b[i])*q_2-(beta_13+gamma_13*X_b[i])*q_3;
b_p1=gamma_11*X_b[i];
u_p1=a_p1*q_sequence-b_p1*q_sequence^2-F_p1[i]*(q_sequence .gt 0);
u_p1_sorted=sortc(q_sequence~u_p1,2);
q_1_optimal=u_p1_sorted[rows(u_p1_sorted),1];
u_p1_optimal=u_p1_sorted[rows(u_p1_sorted),2];
	
a_p2=X_a[i]-MC_p2[i]-(beta_21+gamma_21*X_b[i])*q_1-(beta_23+gamma_23*X_b[i])*q_3;
b_p2=gamma_22*X_b[i];
u_p2=a_p2*q_sequence-b_p2*q_sequence^2-F_p2[i]*(q_sequence .gt 0);
u_p2_sorted=sortc(q_sequence~u_p2,2);
q_2_optimal=u_p2_sorted[rows(u_p2_sorted),1];
u_p2_optimal=u_p2_sorted[rows(u_p2_sorted),2];	
	
a_p3=X_a[i]-MC_p3[i]-(beta_31+gamma_31*X_b[i])*q_1-(beta_32+gamma_32*X_b[i])*q_2;
b_p3=gamma_33*X_b[i];
u_p3=a_p3*q_sequence-b_p3*q_sequence^2-F_p3[i]*(q_sequence .gt 0);
u_p3_sorted=sortc(q_sequence~u_p3,2);
q_3_optimal=u_p3_sorted[rows(u_p3_sorted),1];
u_p3_optimal=u_p3_sorted[rows(u_p3_sorted),2];

eqbm=(q_1_optimal .eq q_1).*(q_2_optimal .eq q_2).*(q_3_optimal .eq q_3);

if eqbm .eq 1;
number_equilibria=number_equilibria+1;
	if number_equilibria .eq 1;
	equilibria=q_1_optimal~q_2_optimal~q_3_optimal;
	eqbm_payoffs=u_p1_optimal~u_p2_optimal~u_p3_optimal;	
	else;
	equilibria=equilibria|(q_1_optimal~q_2_optimal~q_3_optimal);
	eqbm_payoffs=eqbm_payoffs|(u_p1_optimal~u_p2_optimal~u_p3_optimal);	
	endif;
endif;

j=j+1;

endo;

number_of_equilibria[i]=number_equilibria;

if number_of_equilibria[i] .gt 0;

Y1_obs=equilibria[.,1];
Y2_obs=equilibria[.,2];
Y3_obs=equilibria[.,3];	
	
phi_12_obs=beta_12+gamma_12*X_b[i];
phi_13_obs=beta_13+gamma_13*X_b[i];

phi_21_obs=beta_21+gamma_21*X_b[i];
phi_23_obs=beta_23+gamma_23*X_b[i];

phi_31_obs=beta_31+gamma_31*X_b[i];
phi_32_obs=beta_32+gamma_32*X_b[i];
	
phi_1_obs=phi_12_obs.*Y2_obs+phi_13_obs.*Y3_obs;
phi_2_obs=phi_21_obs.*Y1_obs+phi_23_obs.*Y3_obs;
phi_3_obs=phi_31_obs.*Y1_obs+phi_32_obs.*Y2_obs;

phi_1_substitutes=(1+X_b[i])*Y2_obs+(1+X_b[i])*Y3_obs;
phi_2_substitutes=(1+X_b[i])*Y1_obs+(1+X_b[i])*Y3_obs;	
phi_3_substitutes=(1+X_b[i])*Y1_obs+(1+X_b[i])*Y2_obs;

if number_of_equilibria[i] .eq 1;
eqbm_outcome[i,.]=equilibria;
correl_p1[i]=0;
correl_p2[i]=0;	
correl_p3[i]=0;
subst_correl_p1[i]=0;
subst_correl_p2[i]=0;
subst_correl_p3[i]=0;	
else;


if selection_favors_p1 .eq 1;
	eqbm_select=sortc(eqbm_payoffs[.,1]~equilibria,1);
	eqbm_outcome[i,.]=eqbm_select[rows(eqbm_select),2:cols(eqbm_select)];
endif;	
	

if selection_favors_p2 .eq 1;
	eqbm_select=sortc(eqbm_payoffs[.,2]~equilibria,1);
	eqbm_outcome[i,.]=eqbm_select[rows(eqbm_select),2:cols(eqbm_select)];
endif;


if selection_favors_p3 .eq 1;
	eqbm_select=sortc(eqbm_payoffs[.,3]~equilibria,1);
	eqbm_outcome[i,.]=eqbm_select[rows(eqbm_select),2:cols(eqbm_select)];
endif;

if selection_favors_collusion .eq 1;
	eqbm_select=sortc(eqbm_payoffs[.,1]+eqbm_payoffs[.,2]+eqbm_payoffs[.,3]~equilibria,1);
	eqbm_outcome[i,.]=eqbm_select[rows(eqbm_select),2:cols(eqbm_select)];
endif;

if selection_adaptive_collusion .eq 1;
aux_flip_coin=rndu(1,1);
	if 	aux_flip_coin .ge 1/2; /*They choose the equilibrium that maximizes players 1 and 3's joint payoff*/
	eqbm_select=sortc(eqbm_payoffs[.,1]+eqbm_payoffs[.,3]~equilibria,1);
	eqbm_outcome[i,.]=eqbm_select[rows(eqbm_select),2:cols(eqbm_select)];	
	else;
	eqbm_select=sortc(eqbm_payoffs[.,2]~equilibria,1);
	eqbm_outcome[i,.]=eqbm_select[rows(eqbm_select),2:cols(eqbm_select)];
	endif;
endif;	
		
if selection_adaptive_collusion_bis .eq 1;
aux_flip_coin=rndu(1,1);
	if aux_flip_coin .le 1/3; /*They choose randomly among the equilibria*/
	eqbm_select=sortc(rndn(number_of_equilibria[i],1)~equilibria,1);
	eqbm_outcome[i,.]=eqbm_select[1,2:cols(eqbm_select)];	
	elseif 	(aux_flip_coin .ge 1/3).*(aux_flip_coin .lt 2/3); /*They choose the equilibrium that maximizes players 1 and 3's joint payoff*/
	eqbm_select=sortc(eqbm_payoffs[.,1]+eqbm_payoffs[.,3]~equilibria,1);
	eqbm_outcome[i,.]=eqbm_select[rows(eqbm_select),2:cols(eqbm_select)];	
	else; /*They choose the equilibrium that maximizes player 2's payoffs*/
	eqbm_select=sortc(eqbm_payoffs[.,2]~equilibria,1);
	eqbm_outcome[i,.]=eqbm_select[rows(eqbm_select),2:cols(eqbm_select)];
	endif;
endif;

if selection_favors_monopoly .eq 1;
monopoly_eqbm=(equilibria[.,1] .gt 0)+(equilibria[.,2] .gt 0)+(equilibria[.,3] .gt 0);
monopoly_eqbm=(monopoly_eqbm .eq 1);	
	if sumc(monopoly_eqbm .gt 0);
	equilibria=selif(equilibria, monopoly_eqbm .eq 1);
	eqbm_payoffs=selif(eqbm_payoffs, monopoly_eqbm .eq 1);
	eqbm_select=sortc(eqbm_payoffs[.,1]+eqbm_payoffs[.,2]+eqbm_payoffs[.,3]~equilibria,1);	
	eqbm_outcome[i,.]=eqbm_select[rows(eqbm_select),2:cols(eqbm_select)];
	else;
	eqbm_select=sortc(rndn(number_of_equilibria[i],1)~equilibria,1);
	eqbm_outcome[i,.]=eqbm_select[1,2:cols(eqbm_select)];	
	endif;
endif;	
		
if maxc(selection_favors_p1|selection_favors_p2|selection_favors_p3|selection_favors_monopoly) .eq 0;
eqbm_select=sortc(rndn(number_of_equilibria[i],1)~equilibria,1);
eqbm_outcome[i,.]=eqbm_select[1,2:cols(eqbm_select)];	
endif;

	
sigma_1=stdc(Y1_obs);
sigma_2=stdc(Y2_obs);
sigma_3=stdc(Y3_obs);

aux_correl_p1=corrx(Y1_obs~phi_1_obs);
aux_correl_p2=corrx(Y2_obs~phi_2_obs);	
aux_correl_p3=corrx(Y3_obs~phi_3_obs);		

substitutes_correl_p1=corrx(Y1_obs~phi_1_substitutes);
substitutes_correl_p2=corrx(Y2_obs~phi_2_substitutes);	
substitutes_correl_p3=corrx(Y3_obs~phi_3_substitutes);

if 	(sigma_1 .gt 0).*(sigma_2 .gt 0).*(sigma_3 .gt 0) .eq 1;
correl_p1[i]=aux_correl_p1[1,2];
correl_p2[i]=aux_correl_p2[1,2];	
correl_p3[i]=aux_correl_p3[1,2];
if stdc(phi_1_substitutes .gt 0); 	
subst_correl_p1[i]=substitutes_correl_p1[1,2];
else;
subst_correl_p1[i]=0;
endif;	
if stdc(phi_2_substitutes .gt 0);	
subst_correl_p2[i]=substitutes_correl_p2[1,2];	
else;
subst_correl_p2[i]=0;
endif;
if stdc(phi_3_substitutes .gt 0);
subst_correl_p3[i]=substitutes_correl_p3[1,2];
else;
subst_correl_p3[i]=0;	
endif;	
	
elseif 	(sigma_1 .eq 0).*(sigma_2 .gt 0).*(sigma_3 .gt 0) .eq 1;
correl_p1[i]=0;
correl_p2[i]=aux_correl_p2[1,2];	
correl_p3[i]=aux_correl_p3[1,2];
subst_correl_p1[i]=0;
if stdc(phi_2_substitutes .gt 0);
subst_correl_p2[i]=substitutes_correl_p2[1,2];
else;
subst_correl_p2[i]=0;
endif;
if stdc(phi_3_substitutes .gt 0);
subst_correl_p3[i]=substitutes_correl_p3[1,2];	
else;
subst_correl_p3[i]=0;
endif;

	
elseif 	(sigma_1 .gt 0).*(sigma_2 .eq 0).*(sigma_3 .gt 0) .eq 1;
correl_p1[i]=aux_correl_p1[1,2];
correl_p2[i]=0;	
correl_p3[i]=aux_correl_p3[1,2];	
if stdc(phi_1_substitutes .gt 0);
subst_correl_p1[i]=substitutes_correl_p1[1,2];
else;
subst_correl_p1[i]=0;
endif;
subst_correl_p2[i]=0;	
if stdc(phi_2_substitutes .gt 0);
subst_correl_p3[i]=substitutes_correl_p3[1,2];
else;
subst_correl_p3[i]=0;
endif;	
	
elseif 	(sigma_1 .gt 0).*(sigma_2 .gt 0).*(sigma_3 .eq 0) .eq 1;
correl_p1[i]=aux_correl_p1[1,2];
correl_p2[i]=aux_correl_p2[1,2];	
correl_p3[i]=0;
if stdc(phi_1_substitutes .gt 0);	
subst_correl_p1[i]=substitutes_correl_p1[1,2];
else;
subst_correl_p1[i]=0;
endif;
if stdc(phi_2_substitutes .gt 0);
subst_correl_p2[i]=substitutes_correl_p2[1,2];	
else;
subst_correl_p2[i]=0;
endif;	
subst_correl_p3[i]=0;
	
else;
correl_p1[i]=0;
correl_p2[i]=0;	
correl_p3[i]=0;
subst_correl_p1[i]=0;
subst_correl_p2[i]=0;	
subst_correl_p3[i]=0;
	
endif;
	
/*aux_correl_p1=varCovx(Y1_obs~phi_1_obs);
aux_correl_p2=varCovx(Y2_obs~phi_2_obs);	
aux_correl_p3=varCovx(Y3_obs~phi_3_obs);	
	
correl_p1[i]=aux_correl_p1[1,2];	
correl_p2[i]=aux_correl_p2[1,2];
correl_p3[i]=aux_correl_p3[1,2];*/

endif;


endif;

i=i+1;
endo;

Y1=eqbm_outcome[.,1];
Y2=eqbm_outcome[.,2];
Y3=eqbm_outcome[.,3];

avg_number_of_equilibria[sim]=meanc(number_of_equilibria);
median_number_of_equilibria[sim]=quantile(number_of_equilibria,0.5);

avg_within_correlat_p1[sim]=meanc(correl_p1);
avg_within_correlat_p2[sim]=meanc(correl_p2);
avg_within_correlat_p3[sim]=meanc(correl_p3);

correl_Ys=corrx(Y1~Y2~Y3);

across_correlat_Y1_Y2[sim]=correl_Ys[1,2];
across_correlat_Y1_Y3[sim]=correl_Ys[1,3];
across_correlat_Y2_Y3[sim]=correl_Ys[2,3];


/*TEST-STATISTIC CODE BEGINS HERE*/

b_L=0.00001;

y1_max=upper_q;
y2_max=upper_q;
y3_max=upper_q;

X=X_a~X_b~X_mc;

cont_covars=X;

z=cols(cont_covars); /*Number of continuous covariates in X*/

L=rows(X);

epsilon_h=(9/10)*1/(4*z*(2*z+1));
alpha_h=1/(4*z)-epsilon_h; 
sup=30;
c1=323323/24159191040000;
c2=-(7436429/4696546738176000000);
c3=1509595087/33815136514867200000000000;
c4=-(73538846381/146081389744226304000000000000000);
c5=19046561212679/6815573319906622439424000000000000000000;
c6=-(922892466032537/110412287782487283518668800000000000000000000000);
c7=436092044389001/31798738881356337653376614400000000000000000000000000;
c8=-(143474282603981329/12363349677071344079632827678720000000000000000000000000000000);
c9=7604136978011010437/1922748141778135431264497360594534400000000000000000000000000000000000;
Rk=173955989109241405262753588031/772455899253990440701354049536;
Kv=129140163000000000000000000/1440973;
M=18;
c_h=2*((sqrt(pi)*((M!)^3)*Rk)/((2*M)*((2*M)!)*(Kv^2)))^(1/(2*M+1));
bandwidths_trim=c_h*stdc(cont_covars)'*(L^-alpha_h);
bandwidths=c_h*stdc(cont_covars)'*(L^-alpha_h);


proc kernels(x);
local cont_values, x_val_cont, psi, kernel_matr;
local kernel_matr_normalized, kernel_vector, i, s_2;

s_2=ones(L,z)*sup^2;
x_val_cont=x[1:z];
cont_values=ones(L,z).*x_val_cont;
psi=(cont_covars-cont_values)./bandwidths;

kernel_matr=(c1*(s_2-psi^2)^2+c2*(s_2-psi^2)^4+c3*(s_2-psi^2)^6
+c4*(s_2-psi^2)^8+c5*(s_2-psi^2)^10+c6*(s_2-psi^2)^12
+c7*(s_2-psi^2)^14+c8*(s_2-psi^2)^16+c9*(s_2-psi^2)^18).*(abs(psi) .le sup);

kernel_matr_normalized=kernel_matr./bandwidths;
kernel_vector=ones(L,1);

i=1;
do while i .le z;
kernel_vector=kernel_vector.*kernel_matr_normalized[.,i];
i=i+1;
endo;

retp(kernel_vector);
endp;

/*M=6;
epsilon_h=10^(-5);
alpha_h=1/(2*M)+epsilon_h; 
c_h=0.5;
bandwidths=c_h*stdc(cont_covars)'*(L^-alpha_h);
supp=10;*/

/*proc kernelsb(x);
local a0_U, a1_U, a2_U, a3_U, a4_U, a5_U, a6_U, a7_U, a8_U, a9_U, a10_U, a11_U, a12_U, a13_U, a14_U;
local a0_L, a1_L, a2_L, a3_L, a4_L, a5_L, a6_L, a7_L, a8_L, a9_L, a10_L, a11_L, a12_L, a13_L, a14_L;
local a0, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14;
local c0, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10, c11, c12, c13, c14;
local x_near_lower_bound, x_near_upper_bound, x_near_interior;
local covars, psi, kernel_matr, kernel_vector, jj;
local x_near_boundary, x_near_both_boundaries, closer_to_lower_bound;
local U_psi, L_psi;
local kj;
local x_near_lower_bound_only, x_near_upper_bound_only;

covars=x;

psi=(cont_covars-ones(L,z).*covars)./bandwidths;

c1=327/13660;
c2=-(21/13660);
c3=1197/68300000;

kernel_matr=(supp-abs(psi)).*(c1+c2*psi^2+c3*psi^4).*(abs(psi) .le supp)./bandwidths;

kernel_vector=ones(L,1);

jj=1;
do while jj .le z;
kernel_vector=kernel_vector.*kernel_matr[.,jj];
jj=jj+1;
endo;

retp(kernel_vector);
endp;*/


kernel_matrix=zeros(L,L);

i=1;
do while i .le L;
x_value=cont_covars[i,.];
kernel_matrix[.,i]=kernels(x_value);
i=i+1;
endo;

kernel_matrix=diagrv(kernel_matrix,zeros(L,1));

fx=meanc(kernel_matrix);

trim_aux=selif(fx, fx .gt 0);
trim_x=(fx .gt 0);
fx=fx.*trim_x+(1-trim_x).*minc(trim_aux);
trimming_p1=trim_x.*(Y1 .le y1_max);
trimming_p2=trim_x.*(Y2 .le y2_max);
trimming_p3=trim_x.*(Y3 .le y3_max);

trimming_all=(trimming_p1).*(trimming_p2).*(trimming_p3);

thr_dis=200;

/*Strategic interaction index (constant strategic parameters)*/
/*V_12=ones(L,1);
V_13=ones(L,1);
V_21=ones(L,1);
V_23=ones(L,1);
V_31=ones(L,1);
V_32=ones(L,1);*/

V_12=ones(L,1)~X_b;
V_13=ones(L,1)~X_b;
V_21=ones(L,1)~X_b;
V_23=ones(L,1)~X_b;
V_31=ones(L,1)~X_b;
V_32=ones(L,1)~X_b;


if confidence_set_estimation .eq 1;
new_state_G_12A = rndCreateState("mrg32k3a", 54443385);
new_state_G_12B = rndCreateState("mrg32k3a", 77688787);	
new_state_B_12A = rndCreateState("mrg32k3a", 34411201);
new_state_B_12B = rndCreateState("mrg32k3a", 09801939);
{G_12A,state_G12}=rndu(gridsize_thetas_CS,1,new_state_G_12A);
{G_12B,state_G12}=rndu(gridsize_thetas_CS,1,new_state_G_12B);	
{B_12A,state_B12}=rndu(gridsize_thetas_CS,1,new_state_B_12A);
{B_12B,state_B12}=rndu(gridsize_thetas_CS,1,new_state_B_12B);
	
new_state_G_13A = rndCreateState("mrg32k3a", 12948223);
new_state_G_13B = rndCreateState("mrg32k3a", 029484001);	
new_state_B_13A = rndCreateState("mrg32k3a", 638561234);
new_state_B_13B = rndCreateState("mrg32k3a", 044569223);
{G_13A,state_G13}=rndu(gridsize_thetas_CS,1,new_state_G_13A);
{G_13B,state_G13}=rndu(gridsize_thetas_CS,1,new_state_G_13B);	
{B_13A,state_B13}=rndu(gridsize_thetas_CS,1,new_state_B_13A);
{B_13B,state_B13}=rndu(gridsize_thetas_CS,1,new_state_B_13B);

new_state_G_21A = rndCreateState("mrg32k3a", 345769105);
new_state_G_21B = rndCreateState("mrg32k3a", 206727749);	
new_state_B_21A = rndCreateState("mrg32k3a", 206824350);
new_state_B_21B = rndCreateState("mrg32k3a", 613110134);
{G_21A,state_G21}=rndu(gridsize_thetas_CS,1,new_state_G_21A);
{G_21B,state_G21}=rndu(gridsize_thetas_CS,1,new_state_G_21B);	
{B_21A,state_B21}=rndu(gridsize_thetas_CS,1,new_state_B_21A);
{B_21B,state_B21}=rndu(gridsize_thetas_CS,1,new_state_B_21B);

new_state_G_23A = rndCreateState("mrg32k3a", 209211114);
new_state_G_23B = rndCreateState("mrg32k3a", 093733332);	
new_state_B_23A = rndCreateState("mrg32k3a", 112320006);
new_state_B_23B = rndCreateState("mrg32k3a", 330491096);
{G_23A,state_G23}=rndu(gridsize_thetas_CS,1,new_state_G_23A);
{G_23B,state_G23}=rndu(gridsize_thetas_CS,1,new_state_G_23B);	
{B_23A,state_B23}=rndu(gridsize_thetas_CS,1,new_state_B_23A);
{B_23B,state_B23}=rndu(gridsize_thetas_CS,1,new_state_B_23B);
	
new_state_G_31A = rndCreateState("mrg32k3a", 777631093);
new_state_G_31B = rndCreateState("mrg32k3a", 111994765);	
new_state_B_31A = rndCreateState("mrg32k3a", 000122345);
new_state_B_31B = rndCreateState("mrg32k3a", 333783064);
{G_31A,state_G31}=rndu(gridsize_thetas_CS,1,new_state_G_31A);
{G_31B,state_G31}=rndu(gridsize_thetas_CS,1,new_state_G_31B);	
{B_31A,state_B31}=rndu(gridsize_thetas_CS,1,new_state_B_31A);
{B_31B,state_B31}=rndu(gridsize_thetas_CS,1,new_state_B_31B);

new_state_G_32A = rndCreateState("mrg32k3a", 222871110);
new_state_G_32B = rndCreateState("mrg32k3a", 019342001);	
new_state_B_32A = rndCreateState("mrg32k3a", 182943220);
new_state_B_32B = rndCreateState("mrg32k3a", 888654002);
{G_32A,state_G32}=rndu(gridsize_thetas_CS,1,new_state_G_32A);
{G_32B,state_G32}=rndu(gridsize_thetas_CS,1,new_state_G_32B);	
{B_32A,state_B32}=rndu(gridsize_thetas_CS,1,new_state_B_32A);
{B_32B,state_B32}=rndu(gridsize_thetas_CS,1,new_state_B_32B);

theta_21_grid=ones(gridsize_thetas_CS,1)*gamma_21+2*(G_21A-G_21B); 
betta_21_grid=ones(gridsize_thetas_CS,1)*beta_21+2*(B_21A-B_21B); 
theta_23_grid=ones(gridsize_thetas_CS,1)*gamma_23+2*(G_23A-G_23B); 
betta_23_grid=ones(gridsize_thetas_CS,1)*beta_23+2*(B_23A-B_23B); 

theta_21_grid=maxc((zeros(gridsize_thetas_CS,1)~theta_21_grid)');
betta_21_grid=maxc((zeros(gridsize_thetas_CS,1)~betta_21_grid)');
theta_23_grid=maxc((zeros(gridsize_thetas_CS,1)~theta_23_grid)');
betta_23_grid=maxc((zeros(gridsize_thetas_CS,1)~betta_23_grid)');

theta_12_grid=theta_21_grid;
betta_12_grid=betta_21_grid;
theta_32_grid=theta_23_grid;
betta_32_grid=betta_23_grid;

/*theta_12_grid=ones(gridsize_thetas_CS,1)*gamma_12+2*(G_12A-G_12B); 
betta_12_grid=ones(gridsize_thetas_CS,1)*beta_12+2*(B_12A-B_12B);*/ 
theta_13_grid=ones(gridsize_thetas_CS,1)*gamma_13+10*(G_13A-G_13B); 
betta_13_grid=ones(gridsize_thetas_CS,1)*beta_13+2*(B_13A-B_13B);

theta_13_grid=minc((zeros(gridsize_thetas_CS,1)~theta_13_grid)');
betta_13_grid=maxc((zeros(gridsize_thetas_CS,1)~betta_13_grid)');

theta_31_grid=theta_13_grid;
betta_31_grid=betta_13_grid;

/*theta_31_grid=ones(gridsize_thetas_CS,1)*gamma_31+2*(G_31A-G_31B); 
betta_31_grid=ones(gridsize_thetas_CS,1)*beta_31+2*(B_31A-B_31B); 
theta_32_grid=ones(gridsize_thetas_CS,1)*gamma_32+2*(G_32A-G_32B); 
betta_32_grid=ones(gridsize_thetas_CS,1)*beta_32+2*(B_32A-B_32B);*/

endif;

if true_parameters_test .eq 1;
theta_12_grid=gamma_12; betta_12_grid=beta_12;
theta_13_grid=gamma_13; betta_13_grid=beta_13;
theta_21_grid=gamma_21; betta_21_grid=beta_21;
theta_23_grid=gamma_23; betta_23_grid=beta_23;
theta_31_grid=gamma_31; betta_31_grid=beta_31;
theta_32_grid=gamma_32; betta_32_grid=beta_32;
endif;

if symmetric_first_scenario .eq 1;
theta_12_grid=1; betta_12_grid=1;
theta_13_grid=1; betta_13_grid=1;
theta_21_grid=1; betta_21_grid=1;
theta_23_grid=1; betta_23_grid=1;
theta_31_grid=1; betta_31_grid=1;
theta_32_grid=1; betta_32_grid=1;
endif;
	
if symmetric_second_scenario .eq 1;
theta_12_grid=1; betta_12_grid=0;
theta_13_grid=1; betta_13_grid=0;
theta_21_grid=1; betta_21_grid=0;
theta_23_grid=1; betta_23_grid=0;
theta_31_grid=1; betta_31_grid=0;
theta_32_grid=1; betta_32_grid=0;
endif;

if symmetric_third_scenario .eq 1;
theta_12_grid=0; betta_12_grid=1;
theta_13_grid=0; betta_13_grid=1;
theta_21_grid=0; betta_21_grid=1;
theta_23_grid=0; betta_23_grid=1;
theta_31_grid=0; betta_31_grid=1;
theta_32_grid=0; betta_32_grid=1;
endif;


 
rrr=1;
do while rrr .le gridsize_thetas_CS;
theta_12=theta_12_grid[rrr]; betta_12=betta_12_grid[rrr];
theta_13=theta_13_grid[rrr]; betta_13=betta_13_grid[rrr];
theta_21=theta_21_grid[rrr]; betta_21=betta_21_grid[rrr];
theta_23=theta_23_grid[rrr]; betta_23=betta_23_grid[rrr];
theta_31=theta_31_grid[rrr]; betta_31=betta_31_grid[rrr];
theta_32=theta_32_grid[rrr]; betta_32=betta_32_grid[rrr];


phi_12_matrix=V_12*(betta_12|theta_12);
phi_13_matrix=V_13*(betta_13|theta_13);

phi_21_matrix=V_21*(betta_21|theta_21);
phi_23_matrix=V_23*(betta_23|theta_23);

phi_31_matrix=V_31*(betta_31|theta_31);
phi_32_matrix=V_32*(betta_32|theta_32);

E_Y1_le_y1=meanc((Y1 .le Y1').*kernel_matrix)./fx;
E_Y2_le_y2=meanc((Y2 .le Y2').*kernel_matrix)./fx;
E_Y3_le_y3=meanc((Y3 .le Y3').*kernel_matrix)./fx;

E_Y1_le_y1=minc((E_Y1_le_y1~ones(L,1))');
E_Y2_le_y2=minc((E_Y2_le_y2~ones(L,1))');
E_Y3_le_y3=minc((E_Y3_le_y3~ones(L,1))');

E_Y1_le_y1=maxc((E_Y1_le_y1~zeros(L,1))');
E_Y2_le_y2=maxc((E_Y2_le_y2~zeros(L,1))');
E_Y3_le_y3=maxc((E_Y3_le_y3~zeros(L,1))');

E_Y2_phi_12=zeros(L,1);
E_Y3_phi_13=zeros(L,1);

E_Y1_phi_21=zeros(L,1);
E_Y3_phi_23=zeros(L,1);

E_Y1_phi_31=zeros(L,1);
E_Y2_phi_32=zeros(L,1);

E_Y2_phi_12_Y1_le_y1=zeros(L,1);
E_Y3_phi_13_Y1_le_y1=zeros(L,1);

E_Y1_phi_21_Y2_le_y2=zeros(L,1);
E_Y3_phi_23_Y2_le_y2=zeros(L,1);

E_Y1_phi_31_Y3_le_y3=zeros(L,1);
E_Y2_phi_32_Y3_le_y3=zeros(L,1);

E_Y1_le_y1_big_phi1=zeros(L,1);
E_Y2_le_y2_big_phi2=zeros(L,1);
E_Y3_le_y3_big_phi3=zeros(L,1);

matrix_R1=zeros(L,1);
matrix_R2=zeros(L,1);
matrix_R3=zeros(L,1);


i=1;
do while i .le L;
E_Y2_phi_12[i,.]=(meanc(Y2 .*phi_12_matrix.*kernel_matrix[.,i])/fx[i])';
E_Y3_phi_13[i,.]=(meanc(Y3 .*phi_13_matrix.*kernel_matrix[.,i])/fx[i])';

E_Y1_phi_21[i,.]=(meanc(Y1 .*phi_21_matrix.*kernel_matrix[.,i])/fx[i])';
E_Y3_phi_23[i,.]=(meanc(Y3 .*phi_23_matrix.*kernel_matrix[.,i])/fx[i])';

E_Y1_phi_31[i,.]=(meanc(Y1 .*phi_31_matrix.*kernel_matrix[.,i])/fx[i])';
E_Y2_phi_32[i,.]=(meanc(Y2 .*phi_32_matrix.*kernel_matrix[.,i])/fx[i])';


E_Y2_phi_12_Y1_le_y1[i,.]=(meanc(Y2 .*phi_12_matrix.*(Y1 .le Y1[i]).*kernel_matrix[.,i])/fx[i])';
E_Y3_phi_13_Y1_le_y1[i,.]=(meanc(Y3 .*phi_13_matrix.*(Y1 .le Y1[i]).*kernel_matrix[.,i])/fx[i])';

E_Y1_phi_21_Y2_le_y2[i,.]=(meanc(Y1 .*phi_21_matrix.*(Y2 .le Y2[i]).*kernel_matrix[.,i])/fx[i])';
E_Y3_phi_23_Y2_le_y2[i,.]=(meanc(Y3 .*phi_23_matrix.*(Y2 .le Y2[i]).*kernel_matrix[.,i])/fx[i])';

E_Y1_phi_31_Y3_le_y3[i,.]=(meanc(Y1 .*phi_31_matrix.*(Y3 .le Y3[i]).*kernel_matrix[.,i])/fx[i])';
E_Y2_phi_32_Y3_le_y3[i,.]=(meanc(Y2 .*phi_32_matrix.*(Y3 .le Y3[i]).*kernel_matrix[.,i])/fx[i])';

E_Y1_le_y1_big_phi1[i,.]=E_Y2_phi_12_Y1_le_y1[i,.]+E_Y3_phi_13_Y1_le_y1[i,.];
E_Y2_le_y2_big_phi2[i,.]=E_Y1_phi_21_Y2_le_y2[i,.]+E_Y3_phi_23_Y2_le_y2[i,.];
E_Y3_le_y3_big_phi3[i,.]=E_Y1_phi_31_Y3_le_y3[i,.]+E_Y2_phi_32_Y3_le_y3[i,.];


matrix_R1[i,.]=((E_Y2_phi_12[i,.]+E_Y3_phi_13[i,.])*E_Y1_le_y1[i]-E_Y1_le_y1_big_phi1[i,.]);
matrix_R2[i,.]=((E_Y1_phi_21[i,.]+E_Y3_phi_23[i,.])*E_Y2_le_y2[i]-E_Y2_le_y2_big_phi2[i,.]);
matrix_R3[i,.]=((E_Y1_phi_31[i,.]+E_Y2_phi_32[i,.])*E_Y3_le_y3[i]-E_Y3_le_y3_big_phi3[i,.]);

i=i+1;
endo;

unos_matrix=ones(L,1);

matrix_influence_p1=zeros(L,1);
i=1;
do while i .le L;
matrix_influence_p1[i,.]=
(meanc((1/fx).*(E_Y2_phi_12.*((Y1[i] .le Y1)-E_Y1_le_y1)+E_Y1_le_y1.*(Y2[i]*phi_12_matrix[i,.].*unos_matrix-E_Y2_phi_12)
-(Y2[i].*phi_12_matrix[i,.].*unos_matrix.*(Y1[i] .le Y1)-E_Y2_phi_12_Y1_le_y1)).*(matrix_R1 .ge -b_L).*trimming_p1.*kernel_matrix[.,i]))'
+
(meanc((1/fx).*(E_Y3_phi_13.*((Y1[i] .le Y1)-E_Y1_le_y1)+E_Y1_le_y1.*(Y3[i]*phi_13_matrix[i,.].*unos_matrix-E_Y3_phi_13)
-(Y3[i].*phi_13_matrix[i,.].*unos_matrix.*(Y1[i] .le Y1)-E_Y3_phi_13_Y1_le_y1)).*(matrix_R1 .ge -b_L).*trimming_p1.*kernel_matrix[.,i]))';
i=i+1;
endo;


full_influence_p1=matrix_influence_p1;


matrix_influence_p2=zeros(L,1);
i=1;
do while i .le L;
matrix_influence_p2[i,.]=
(meanc((1/fx).*(E_Y1_phi_21.*((Y2[i] .le Y2)-E_Y2_le_y2)+E_Y2_le_y2.*(Y1[i]*phi_21_matrix[i,.].*unos_matrix-E_Y1_phi_21)
-(Y1[i].*phi_21_matrix[i,.].*unos_matrix.*(Y2[i] .le Y2)-E_Y1_phi_21_Y2_le_y2)).*(matrix_R2 .ge -b_L).*trimming_p2.*kernel_matrix[.,i]))'
+
(meanc((1/fx).*(E_Y3_phi_23.*((Y2[i] .le Y2)-E_Y2_le_y2)+E_Y2_le_y2.*(Y3[i]*phi_23_matrix[i,.].*unos_matrix-E_Y3_phi_23)
-(Y3[i].*phi_23_matrix[i,.].*unos_matrix.*(Y2[i] .le Y2)-E_Y3_phi_23_Y2_le_y2)).*(matrix_R2 .ge -b_L).*trimming_p2.*kernel_matrix[.,i]))';
i=i+1;
endo;


full_influence_p2=matrix_influence_p2;


matrix_influence_p3=zeros(L,1);
i=1;
do while i .le L;
matrix_influence_p3[i,.]=
(meanc((1/fx).*(E_Y1_phi_31.*((Y3[i] .le Y3)-E_Y3_le_y3)+E_Y3_le_y3.*(Y1[i]*phi_31_matrix[i,.].*unos_matrix-E_Y1_phi_31)
-(Y1[i].*phi_31_matrix[i,.].*unos_matrix.*(Y3[i] .le Y3)-E_Y1_phi_31_Y3_le_y3)).*(matrix_R3 .ge -b_L).*trimming_p3.*kernel_matrix[.,i]))'
+
(meanc((1/fx).*(E_Y2_phi_32.*((Y3[i] .le Y3)-E_Y3_le_y3)+E_Y3_le_y3.*(Y2[i]*phi_32_matrix[i,.].*unos_matrix-E_Y2_phi_32)
-(Y2[i].*phi_32_matrix[i,.].*unos_matrix.*(Y3[i] .le Y3)-E_Y2_phi_32_Y3_le_y3)).*(matrix_R3 .ge -b_L).*trimming_p3.*kernel_matrix[.,i]))';
i=i+1;
endo;


full_influence_p3=matrix_influence_p3;

influence_function=full_influence_p1+full_influence_p2+full_influence_p3;

/*I used to throw away the five largest outliers for the influence function, but not anymore*/
/*infl_quantile=quantile(abs(full_influence_all),1-10/L);
indic_infl=(abs(full_influence_all) .lt infl_quantile);*/

/*indic_infl=1;*/ /*This shows I don't throw them away anymore*/

/*variance_all=meanc((full_influence_all.*indic_infl)^2)-meanc(full_influence_all.*indic_infl)^2;*/

tau_1=matrix_R1.*(matrix_R1 .ge -b_L).*trimming_p1;
tau_2=matrix_R2.*(matrix_R2 .ge -b_L).*trimming_p2;
tau_3=matrix_R3.*(matrix_R3 .ge -b_L).*trimming_p3;

tau_all=tau_1+tau_2+tau_3;

outlier_infl=(influence_function .gt quantile(influence_function,0.75)+1.0*ln(L)*(quantile(influence_function,0.75)-quantile(influence_function,0.25)));
outlier_infl=outlier_infl~(influence_function .lt quantile(influence_function,0.25)-1.0*ln(L)*(quantile(influence_function,0.75)-quantile(influence_function,0.25)));
outlier_infl=maxc(outlier_infl');
no_outlier_infl=1-outlier_infl;
influence_function=selif(influence_function, no_outlier_infl);

tau_all_infl=selif(tau_all, no_outlier_infl);

sigma_T=sqrt(stdc(tau_all)^2+2*meanc((influence_function-meanc(influence_function)).*(tau_all_infl-meanc(tau_all_infl)))+stdc(influence_function)^2);

T_1=meanc(tau_1);
T_2=meanc(tau_2);
T_3=meanc(tau_3);

full_numerator=T_1+T_2+T_3;

test_statistics[rrr+gridsize_thetas_CS*(sim-1)]=sqrt(L)*full_numerator./sigma_T;

rejection[rrr+gridsize_thetas_CS*(sim-1)]=(test_statistics[rrr+gridsize_thetas_CS*(sim-1)] .ge c_value);

total_accepted=total_accepted+(1-rejection[rrr+gridsize_thetas_CS*(sim-1)]);


if rejection[rrr+gridsize_thetas_CS*(sim-1)] .eq 0;

if total_accepted .gt 1;
gamma_12_accepted=gamma_12_accepted|theta_12; beta_12_accepted=beta_12_accepted|betta_12;
gamma_13_accepted=gamma_13_accepted|theta_13; beta_13_accepted=beta_13_accepted|betta_13;

gamma_21_accepted=gamma_21_accepted|theta_21; beta_21_accepted=beta_21_accepted|betta_21;
gamma_23_accepted=gamma_23_accepted|theta_23; beta_23_accepted=beta_23_accepted|betta_23;

gamma_31_accepted=gamma_31_accepted|theta_31; beta_31_accepted=beta_31_accepted|betta_31;
gamma_32_accepted=gamma_32_accepted|theta_32; beta_32_accepted=beta_32_accepted|betta_32;
else;
gamma_12_accepted=theta_12; beta_12_accepted=betta_12;
gamma_13_accepted=theta_13; beta_13_accepted=betta_13;

gamma_21_accepted=theta_21; beta_21_accepted=betta_21;
gamma_23_accepted=theta_23; beta_23_accepted=betta_23;

gamma_31_accepted=theta_31; beta_31_accepted=betta_31;
gamma_32_accepted=theta_32; beta_32_accepted=betta_32;	
endif;

endif;

rrr=rrr+1;
endo;

sim=sim+1;
endo;



dfin=date;
if dfin[3] .eq dinit[3];
totaltime=(dfin[4]-dinit[4])/100;
else;

totaltime=(8640000*(dfin[3]-dinit[3])-dinit[4]+dfin[4])/100;

endif;

endif;
